--[[
Raid Excuse Generator V1.3. Thanks go out to all the raiders from Drama - US Korgath. You have inspired this mod and most of the excuses.
Purpose: Automate excuses for why you can't make it to raid.

Usage: 
/eguild to send your excuse to guild chat.
/eraid to send your excuse to raid chat.
/eginput to type in your own excuse.   (This currently doesn't save over different sessions.)

Have fun doing whatever you're doing besides playing WoW!
Updated for Cataclysm
]]--
local exc = {}
local excuses_personal={}
local EXCUSEN=0;
local LISTN=0;

--  ###########################################################################

function ExcuseGen_OnLoad()

	SlashCmdList["EGRAID"] = egraid;
	SLASH_EGRAID1 = "/egraid";
	SlashCmdList["EGGUILD"] = eguild;
	SLASH_EGGUILD1 = "/eguild";
	SlashCmdList["EGHELP"] = eghelp;
	SLASH_EGHELP1 = "/eghelp";
	SlashCmdList["EGCLEAR"] = egclear;
	SLASH_EGCLEAR1 = "/egclear";
	SlashCmdList["EGINPUT"] = eginput;
	SLASH_EGINPUT1 = "/eginput";
	SlashCmdList["EGLIST"] = eglist;
	SLASH_EGLIST1 = "/eglist";
			
	ExcuseGen_initarray();
	
	if ( DEFAULT_CHAT_FRAME ) then
		DEFAULT_CHAT_FRAME:AddMessage("|cFF888888Raid Excuse Generator loaded! Ready to AFK progression.\nType /reg for options.")
	end
end

function eglist()
	local datatext="";
	ExcuseGen:Show();
	EGNote:Show();
	EGScrollBar:Show();

	for i,k in pairs(exc) do
		datatext=datatext .. "Excuse #"..i.." "..k .. "\n\n"
	end

	EGNote:SetText(datatext);
	LISTN=1;
end
	
function eginput(toggle)
	LISTN=0;
	ExcuseGen:Show();
	EGNote:Show();
	EGScrollBar:Show();
end

function egclear()
ExcuseGen_initarray();
excuses_personal={};
end

function ExcuseGen_Edit_Exit()
	ExcuseGen_Save_Text();
	EGNote:SetText("");
	EGNote:Hide();
	ExcuseGen:Hide();
end


function ExcuseGen_Save_Text()

if (LISTN==0) then

local dataset = EGNote:GetText();

if string.sub(dataset, string.len(dataset)) ~= "\n" then
	dataset = dataset.."\n"
end
for k in string.gmatch(dataset, "[^\n]+") do
	table.insert(exc, k)
	table.insert(excuses_personal, k)
end

EGNote:SetText("");
end

end

--  ###########################################################################
function eghelp()
	if (DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage("Type /eguild to send a random excuse to guild chat.");
		DEFAULT_CHAT_FRAME:AddMessage("Type /egraid to send a random excuse to raid chat.");
		DEFAULT_CHAT_FRAME:AddMessage("Type /eginput to type in your own excuses.");
		DEFAULT_CHAT_FRAME:AddMessage("Type /eglist to list all the excuses.");
		DEFAULT_CHAT_FRAME:AddMessage("Type /egclear to clear your personal excuses and reset the list to default.");
		DEFAULT_CHAT_FRAME:AddMessage("Type /eguild or /eraid followed by a number to send that specific excuse.\nExcuse numbers can be found in the /eglist."); 
	end
end

function ExcuseGen_initarray()
	exc = {
	"I'm sorry guys I have exams I need to study for this week. I'll be back to raid on loot day. I mean Tuesday.",
	"I'm getting kind of bored with WoW. I'm going to take a little break (now that I have all my loot). IM me if you need me. I might help. (probably not)",
	"Going on a Sea World world tour. Got lost. I'll be back to raid some time.",
	"Gonna go see Inception tonight, so I can't make it to raid. I'll be back for Cataclysm though.",
	"Got called into work. Sorry I missed the raid guys.",
	"My class schedule for the next 11 weeks changed. Sorry guys but I'm going to be late Monday, Wednesday, and Friday. I'll be around for Tuesday though, so don't worry!",
	"Spending the day swimming in a lake. Might get water logged. Call my cell if you need me for raid. Hopefully everything will be cleared by then.",
	"My alarm clock broke and the power went out. Sorry I missed the raid.",
	"Going on vacation to Florida. I'll be back to raid if the alligators don't eat me.",
	"Computer burning out. Smoke starts billowing. My power supply is dead. I'll be back to raid in about two months.",
	"Sorry, can't make it tonight I have a family dinner.",
	"My electric company went bankrupt, so I won't be able to raid or connect to the internet until I move out of a 3rd world country.",
	"My friend was in the hospital and I've been visiting her. That's why I haven't been able to raid for the past two months. Sorry. PS I'm a resto shaman.",
	"I can't really stand to look at WoW right now. My e-girlfriend's sister sent me an in-game mail saying she died. I need to stop raiding during my period of mourning.",
	"I will be on time and ready to raid every day this week. I will be using all consumables throughout the raid. Woops, I meant I can't raid tonight, sorry.",
	"I know I just joined the guild, but I can't raid tonight because I need to play arena because my partner can only be on tonight.",
	"If I'm not getting loot I'm not coming to raid, sorry guys. -- Maimer, gnome warlock, US Korgath original",
	"Going to an outdoor weightlifting party at the beach with fellow supermodels and bodybuilders. Probably going to be late by 30 minutes to an hour.",
	"<Insert generic excuse for missing raid>. I will be back for the next fresh clear.",
	"Taking an hour nap cos i havn't slept, my alarm is on the other side of the room so i should be gravy. Later.",
	"See u in a few weeks after the pvpers get their loot since im a flake anyways see ya :>",
	"Sorry, my internet is out otherwise I would've come to raid. (said while on vent)",
	"Instead of reinstalling wow, im just going to reformat. So, if im late, this is why.",
	}
	
end

function ExcuseGen_build()
-- wanted to make excuses_personal entries load into the end of exc. wasn't working properly
	if (excuses_personal[1]~=nil) then 
		for i, v in pairs(excuses_personal) do
			table.insert(exc,v)
		end
	end
	
end

function ExcuseGen_generate()
	if (EXCUSEN==0) then 
		ExcuseGen_build();
		EXCUSEN=1;
	end 

	local inputString = exc[math.random(table.getn(exc))]

	return inputString
end

function egraid(arg)
	x = tonumber(arg)
	if (x~=nil) then
		if (x>0 and x<=#exc) then
			SendChatMessage(exc[x],"RAID")
		else
			DEFAULT_CHAT_FRAME:AddMessage("Invalid number. Please check /eglist for the proper excuse number.");
		end
	else
		SendChatMessage(ExcuseGen_generate(), "RAID")
	end
		
end

function eguild(arg)
	x = tonumber(arg)

	if (x~=nil) then
		if (x>0 and x<=#exc) then
			SendChatMessage(exc[x],"GUILD")
		else
			DEFAULT_CHAT_FRAME:AddMessage("Invalid number. Please check /eglist for the proper excuse number.");
		end
	else
		SendChatMessage(ExcuseGen_generate(), "GUILD")
	end
end

